// EnhMetafileButtonDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "EnhMetafileButtonDlg.h"
#include "EnhMetafileButtonDlgDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

LOGFONT lf;


/////////////////////////////////////////////////////////////////////////////
// CEnhMetafileButtonDlgDlg dialog

CEnhMetafileButtonDlgDlg::CEnhMetafileButtonDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CEnhMetafileButtonDlgDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEnhMetafileButtonDlgDlg)
	m_bUseEnhMF = FALSE;
	m_bStrechEnhMF = FALSE;
	m_bHotlight = FALSE;
	m_bCheckable = FALSE;
	m_bEnableToolTips = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CEnhMetafileButtonDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnhMetafileButtonDlgDlg)
	DDX_Check(pDX, IDC_CHECK_USE_ENH_MF, m_bUseEnhMF);
	DDX_Check(pDX, IDC_CHECK_STRECH_ENH_MF, m_bStrechEnhMF);
	DDX_Check(pDX, IDC_CHECK_HOTLIGHT, m_bHotlight);
	DDX_Check(pDX, IDC_CHECK_CHECKABLE, m_bCheckable);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CEnhMetafileButtonDlgDlg, CDialog)
	//{{AFX_MSG_MAP(CEnhMetafileButtonDlgDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_CHECK_USE_ENH_MF, OnUseEnhMf)
	ON_BN_CLICKED(IDC_CHECK_STRECH_ENH_MF, OnSrechEnhMF)
	ON_BN_CLICKED(IDC_CHECK_HOTLIGHT, OnHotlight)
	ON_BN_CLICKED(IDC_CHECK_CHECKABLE, OnCheckable)
	ON_BN_CLICKED(ID_FONT, OnFont)
	ON_BN_CLICKED(IDC_ENH_METAFILE_BUTTON, OnEnhMetafileButtonClick)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnhMetafileButtonDlgDlg message handlers

BOOL CEnhMetafileButtonDlgDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here

  //------- Enhanced Metafile Button init -------------------------------
	CWnd *pFrame=GetDlgItem(IDC_ENH_METAFILE_BUTTON);
	CRect rcWnd;
	pFrame->GetWindowRect(rcWnd);
	pFrame->DestroyWindow(); //pFrame was just a placeholder anyway.
	ScreenToClient(rcWnd);

  CString String;
  String.LoadString(IDS_ENH_MF_BUTTON_TEXT);

	m_EngMetafileButton.Create(String, WS_CHILD|WS_VISIBLE|BS_PUSHBUTTON|BS_OWNERDRAW|
                             WS_TABSTOP|WS_CLIPCHILDREN|WS_CLIPSIBLINGS,  
                             rcWnd, this, IDC_ENH_METAFILE_BUTTON);

  GetVars();
  //-----------------------------------------

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CEnhMetafileButtonDlgDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

void CEnhMetafileButtonDlgDlg::GetVars()
{
  m_bUseEnhMF = (m_EngMetafileButton.get_FlexButtonStyle() & FB_STYLE_USE_ENH_METAFILE) != 0;
  m_bStrechEnhMF = (m_EngMetafileButton.get_FlexButtonStyle() & FB_STYLE_STRECH_ENH_METAFILE) != 0;
  m_bHotlight = (m_EngMetafileButton.get_FlexButtonStyle() & FB_STYLE_ENABLE_HOTLIGHT) != 0;
  m_bCheckable = (m_EngMetafileButton.get_FlexButtonStyle() & FB_STYLE_CHECKABLE) != 0;

	UpdateData(FALSE);
}


// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CEnhMetafileButtonDlgDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CEnhMetafileButtonDlgDlg::OnUseEnhMf() 
{
	// TODO: Add your control notification handler code here
	if(!UpdateData())
		return;
  
  //--- load resources -------------------------------
  if (m_bUseEnhMF)
    m_EngMetafileButton.LoadEnhMetaFiles(IDR_EMF, IDR_EMF_S, IDR_EMF_F, NULL,  _T("EMF"));

  //---------------------------------------------------
  m_EngMetafileButton.ChangeFlexButtonStyle(FB_STYLE_USE_ENH_METAFILE, m_bUseEnhMF);
  
  if ( ::IsWindow(m_EngMetafileButton) )
    m_EngMetafileButton.Invalidate();
}

void CEnhMetafileButtonDlgDlg::OnSrechEnhMF() 
{
	// TODO: Add your control notification handler code here
	if(!UpdateData())
		return;

  m_EngMetafileButton.ChangeFlexButtonStyle(FB_STYLE_STRECH_ENH_METAFILE, m_bStrechEnhMF);
  
  if ( ::IsWindow(m_EngMetafileButton) )
    m_EngMetafileButton.Invalidate();
}

void CEnhMetafileButtonDlgDlg::OnHotlight() 
{
	// TODO: Add your control notification handler code here
	if(!UpdateData())
		return;

  m_EngMetafileButton.ChangeFlexButtonStyle(FB_STYLE_ENABLE_HOTLIGHT, m_bHotlight);
  
  if ( ::IsWindow(m_EngMetafileButton) )
    m_EngMetafileButton.Invalidate();
}

void CEnhMetafileButtonDlgDlg::OnCheckable() 
{
	// TODO: Add your control notification handler code here
	if(!UpdateData())
		return;

  m_EngMetafileButton.ChangeFlexButtonStyle(FB_STYLE_CHECKABLE, m_bCheckable);
  
  if (m_bCheckable == FALSE)
    m_EngMetafileButton.ChangeFlexButtonState(FB_STATE_CHECKED, FALSE);

  if ( ::IsWindow(m_EngMetafileButton) )
    m_EngMetafileButton.Invalidate();
}

void CEnhMetafileButtonDlgDlg::OnFont() 
{
	// TODO: Add your control notification handler code here

  //---------- init font dialog ---------------------------------------
  CFontDialog dlgFont(&lf);
  
  //---------- run font dialog ---------------------------------------
  if (dlgFont.DoModal() != IDOK)
    return;

  //---------- set font ---------------------------------------
  dlgFont.GetCurrentFont(&lf);

  CFont tempFont;
  if(!tempFont.CreateFontIndirect(&lf))
    return;

  m_EngMetafileButton.SetFont(&tempFont,TRUE);
  tempFont.Detach();

  //----------- set color --------------------------------------
  m_EngMetafileButton.m_ForeColor =  dlgFont.GetColor();

  if ( ::IsWindow(m_EngMetafileButton) )
    m_EngMetafileButton.Invalidate();

}

void CEnhMetafileButtonDlgDlg::OnEnhMetafileButtonClick() 
{
	// ... do something
  CWnd *pOK_Button = GetDlgItem(IDOK);
  pOK_Button->EnableWindow(!pOK_Button->IsWindowEnabled());
}
