// FlexButton.h
// (c) STANKIN NCs Lab 
// author Martinov G.M.
// created 2002
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_FLEXBUTTON_H__E8B2565F_5B1E_4C6B_ADBB_1F9E783C44A9__INCLUDED_)
#define AFX_FLEXBUTTON_H__E8B2565F_5B1E_4C6B_ADBB_1F9E783C44A9__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// FlexButton.h : header file
//

#include <afxctl.h>
#define FB_NUMBER_OF_BUTTON_INDEX_STATE 4 //
#define FB__INDEX_STATE_NORMAL          0 //
#define FB__INDEX_STATE_SELECTED        1 // selected button
#define FB__INDEX_STATE_FOCUS           2 // focused button
#define FB__INDEX_STATE_DISABLED        3 // disabled button

/////////////////////////////////////////////////////////////////////////////
// Flex Button State and Style flags

// State flags
#define FB_STATE_HOTLIGHT             0x0001
#define FB_STATE_CHECKED              0x0002
#define FB_STATE_ENABLED			        0x0004
				
// Style flags
#define FB_STYLE_SYSTEM_SELECT_FRAME  0x0001  // Defines whether the button should use system select frame 
                                              // or draw its own frame

#define FB_STYLE_USE_ENH_METAFILE     0x0002  // Defines whether the text or meta file should be used for drawing the button 
                                              // be used for drawing the button
#define FB_STYLE_ENABLE_HOTLIGHT      0x0004  // Enables highlighting

#define FB_STYLE_CHECKABLE            0x0008  // The button acts like check-box 

#define FB_STYLE_FROST_CHECKABLE      0x0010  // [[[   ,           
                                              // ( ,   , , ,      ). ]]]

#define FB_STYLE_STRECH_ENH_METAFILE  0x0020  // [[[      FB_STYLE_USE_ENH_METAFILE
                                              //     ,      .

//////////////////////////////////////////////////////////////
/////////////////
// CFlexButton window
//[[[ FlexButton -   button,  
//        
//  m_dwFlexButtonStyle. ]]]

//##ModelId=3DC9619C025C
class CFlexButton : 
public CButton  
{
// Construction
public:
	//##ModelId=3DC9619C02B6
	CFlexButton();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CFlexButton)
	public:
	//[[[      
	//       .  
	// FlexTextDrawItem()  MetaFileDrawItem()  
	//    FB_STYLE_USE_ENH_METAFILE 
	//  m_dwFlexButtonStyle.]]]
	//##ModelId=3DC9638A0271
	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	//}}AFX_VIRTUAL

// Implementation
public:
  //##ModelId=3E3C4C83027D
  COLORREF m_BackColor;


  //Use this function when you want to load meta file images identified by 
  //their resource names.
  //Return Value:
  //  TRUE if successful; otherwise FALSE.
  //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
  //##ModelId=3E25785701D7
  BOOL LoadEnhMetaFiles(UINT nIDMetaFileResource, UINT nIDMetaFileResourceSel, UINT nIDMetaFileResourceFocus, UINT nIDMetaFileResourceDisabled, LPCTSTR szResourceType = _T("EMF"));

	//[[[   ,   m- 
	//m_dwFlexButtonState. ]]]
  //##ModelId=3E1AF7C80328
  const DWORD& get_FlexButtonState() const;

	//Adds or clears FlexButtonState flags.
	//If the parameter blAdd is set to TRUE, the flag is 
	//added; otherwise the flag is cleared.
  //##ModelId=3E1AF7CA0103
  void ChangeFlexButtonState(DWORD dwNewStateFlag, BOOL blAdd = TRUE);

	//[[[   ,   m- 
	//m_dwFlexButtonStyle. ]]]
  //##ModelId=3E1AF5F40234
  const DWORD& get_FlexButtonStyle() const;

	//Adds or clears FlexButtonStyle flags.
	//If the parameter blAdd is set to TRUE, the flag is 
	//added; otherwise the flag is cleared.
  //##ModelId=3E1AF5F500BA
  void ChangeFlexButtonStyle(DWORD dwNewStyleFlag, BOOL blAdd = TRUE);

  //Use this function when you want to load meta file images identified by 
  //their resource names.
  //Return Value:
  //  TRUE if successful; otherwise FALSE.
  //##ModelId=3E1565910318
  BOOL LoadEnhMetaFiles(LPCTSTR lpszMetaFileResource, LPCTSTR lpszMetaFileResourceSel, LPCTSTR lpszMetaFileResourceFocus, LPCTSTR lpszMetaFileResourceDisabled);

  //The pen for drawing a dot frame of selected and focused button. The pen is 
  //created in the constructor and the graphical object is deleted in the 
  //destructor.
	//##ModelId=3DD24FC5022E
	CPen m_DotPen;


  //[[[   ]]]
	//##ModelId=3DC9626F0165
	COLORREF m_ForeColor;

	//##ModelId=3DC9619C02C0
	virtual ~CFlexButton();
private:
	//[[[    HENHMETAFILE,  
	// .    
	//LoadEnhMetaFiles(). ]]]
  //##ModelId=3E258CC70343
  HENHMETAFILE m_hMetaFileArray [FB_NUMBER_OF_BUTTON_INDEX_STATE];

  //##ModelId=3E2DDACD02CB
  IPicture* m_IPictureAarray[FB_NUMBER_OF_BUTTON_INDEX_STATE];

  //##ModelId=3E256FC80385
  UnLoad();

	//[[[        
	//DrawItem(). 
	// : FB_STATE_HOTLIGHT  
	//FB_STATE_CHECKED. ]]]
  //##ModelId=3E1AF77A0389
  DWORD m_dwFlexButtonState;

	//[[[      . 
	//    :
	//  FB_STYLE_SYSTEM_SELECT_FRAME - defines whether the 
	//button should use a system frame or draw its own one.
	//  FB_STYLE_USE_ENH_METAFILE - defines whether the text 
	//or metafile should be used for drawing the button. When 
	//the flag FB_STYLE_USE_ENH_METAFILE is set, the drawing 
	//function DrawItem() uses meta file, otherwise it uses 
	//text.
	//  FB_STYLE_ENABLE_HOTLIGHT -  (highlights) 
	//,      ;
	//  FB_STYLE_CHECKABLE -   , 
	//  heck-. 
	//  FB_STYLE_FROST_CHECKABLE -    
	//,        
	//   ( ,   , 
	//, ,      
	//). ]]]
  //##ModelId=3E1AF59C010B
  DWORD m_dwFlexButtonStyle;

	//Clears all enhanced metafile handlers. The function is 
	//called automatically in the destructor and before 
	//loading new meta files in LoadEnhMetaFiles().
  //##ModelId=3E1561F10039
  void ClearEnhMetaFileHandlers();

	//Internal function for drawing button text. [[[  
	// ,      , 
	//       
	//  .  ]]]
	//##ModelId=3DD3E5BA01CE
  void FlexTextDrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);


	//[[[  .    
	//  .     
	//    MetaFileDrawItem(). ]]]
	//##ModelId=3E272499038B
  HPALETTE GetEnhancedMetafilePalette( HENHMETAFILE hMeta );

	// Generated message map functions
protected:
	//Internal function for drawing meta file. [[[  
	//     
	//     
	//    . ]]]
	//##ModelId=3DD3E5BA0297
  void MetaFileDrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);

	//{{AFX_MSG(CFlexButton)
	//Overwritten virtual function for highlighting. 
	//Highlighting is enabled or disabled depending on the 
	//flag FB_STYLE_ENABLE_HOTLIGHT.
	//##ModelId=3E1AFF1A01D7
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	//[[[   " ",  
	//  FB_STYLE_CHECKABLE.]]]
	//##ModelId=3E1C37770005
	afx_msg BOOL OnClicked();
	//}}AFX_MSG
  
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_FLEXBUTTON_H__E8B2565F_5B1E_4C6B_ADBB_1F9E783C44A9__INCLUDED_)
